name: Test

on:
  pull_request:
    branches:
      - master
  push:
    branches:
      - master

jobs:
  rubocop:
    name: Rubocop
    runs-on: ubuntu-latest
    steps:
      - name: Checkout
        uses: actions/checkout@v4
      - name: Set up Ruby 3.2
        uses: ruby/setup-ruby@v1
        with:
          ruby-version: "3.2"
          bundler-cache: true
      - name: Lint
        run: bundle exec rake rubocop

  rspec:
    name: Rspec ruby-${{ matrix.ruby }}-oj-${{ matrix.oj }}
    runs-on: ubuntu-latest
    needs: rubocop
    strategy:
      fail-fast: false
      matrix:
        ruby: ["3.0", "3.1", "3.2"]
        oj: [false, true]
    steps:
      - name: Checkout
        uses: actions/checkout@v4
      - name: Set up Ruby ${{ matrix.ruby }}
        uses: ruby/setup-ruby@v1
        env:
          WITH_OJ_GEM: ${{ matrix.oj }}
        with:
          ruby-version: ${{ matrix.ruby }}
          bundler-cache: true
      - name: Test
        uses: paambaati/codeclimate-action@v5.0.0
        env:
          CC_TEST_REPORTER_ID: be263ef9412dc65a7aa8dfb6e8162d5c7cfb3307fae0a444cde9dd6ca6f52848
          WITH_OJ_GEM: ${{ matrix.oj }}
          RUBY_VERSION: ${{ matrix.ruby }}
        with:
          coverageCommand: bundle exec rake test:coverage
          coverageLocations: coverage/coverage.json:simplecov
      - name: Upload report
        uses: actions/upload-artifact@v3
        with:
          name: allure-results
          path: "*/reports/allure-results/*"
          retention-days: 1

  report:
    name: Allure report
    runs-on: ubuntu-latest
    needs: rspec
    if: always()
    steps:
      - name: Download allure-results
        uses: actions/download-artifact@v3
        with:
          name: allure-results
      - name: Publish allure report
        uses: andrcuns/allure-publish-action@v2.3.0
        env:
          GOOGLE_CLOUD_CREDENTIALS_JSON: ${{ secrets.GOOGLE_CLOUD_CREDENTIALS_JSON }}
          GITHUB_AUTH_TOKEN: ${{ secrets.GITHUB_TOKEN }}
          ALLURE_JOB_NAME: rspec
        with:
          storageType: gcs
          resultsGlob: "*/reports/allure-results"
          bucket: allure-test-reports
          prefix: allure-ruby/$GITHUB_REF
          updatePr: description
          summary: behaviors
          copyLatest: true
          ignoreMissingResults: false
          summaryTableType: ascii
